package org.gcube.application.geoportal.service.engine.mongo;

import org.gcube.application.geoportal.common.model.rest.QueryRequest;

public interface MongoManagerI<T> {


    // create

    public T registerNew(T toRegister);

    // update
    public T update(String id,T toSet);

    // delete

    public void delete(String id);

    // get By ID

    public T getByID(String id);

    // query

    public Iterable<T> query(QueryRequest request);

    // materialize

    public T materialize(String id);

    // dematerialize

    public T dematerialize(String id);
    // index

    public T index(String id);

    // deIndex
    public T deIndex(String id);
}
